// BPM_counter.ino
// ESP32 @ IDE 1.8.12

#define BPMpin 34
#define pulseLED 2

unsigned long duration, t0 ;
unsigned int pulseMin = 30, pulseMax = 180;
float pulseRate, pulseRate_old, tol = 8;

void setup() 
{ Serial.begin(250000);
  pinMode(BPMpin, INPUT);
  pinMode(pulseLED, OUTPUT);
}

void loop() 
{ // get pulse rate
  duration = 0;
  t0 = millis();
  while(digitalRead(BPMpin) == 1) 
  { digitalWrite(pulseLED, HIGH); delay(10);
  } 
    
  while(digitalRead(BPMpin) == 0) 
  { digitalWrite(pulseLED, LOW); delay(10);
  }
  
  duration = millis() - t0;
  
  pulseRate = 60000.0 / duration;     // in BPM: 60*1000 ms = 60 s

  if ((pulseRate >= pulseMin) && (pulseRate <= pulseMax) && (abs(pulseRate - pulseRate_old) < tol))
  { Serial.print(pulseMin);   Serial.print(", ");  
    Serial.print(pulseMax);   Serial.print(", ");
    Serial.println(pulseRate);
  }
  pulseRate_old = pulseRate;
}
