// SkinParam.ino
// ESP 32 @ IDE 1.8.12

#include <OneWire.h>
#include <DallasTemperature.h>

const int oneWireBus = 14;     
const int conductPin = 35;

float temperatureC;
int conductVal;
int T_fact = 1;
float SC_cal = 0.01;

OneWire oneWire(oneWireBus);
DallasTemperature sensors(&oneWire);

void setup() 
{ Serial.begin(250000);
  sensors.begin();
  Serial.print("Temperature");
  Serial.print("Conductivity");
  delay(1000);
}

void loop() 
{ // Temperature @ DS18x20
  sensors.requestTemperatures(); 
  temperatureC = sensors.getTempCByIndex(0);
  Serial.print(T_fact * temperatureC);
  Serial.print(", ");

  // Conductivity
  conductVal = analogRead(conductPin);
  Serial.println(SC_cal*conductVal);
  
  delay(1000);
}
